#version 330

layout(std140) uniform Matrices
{
  mat4 mMat;
  mat4 vMat;
  mat4 pMat;
};

layout(std140) uniform DirectionalLight
{
  vec4 color;
  vec4 direction;
  float intensity;
}
directionalLight;

layout(std140) uniform Material
{
  vec4 ambient;
  vec4 diffuse;
  vec4 specular;
  float shininess;
}
material;

in gsData
{
  vec3 fragPos;
  vec3 normal;
  vec3 baryCoord;
}
gsOut;

out vec4 fragColor;

float edgeFactor();

void main()
{
  //if (gsOut.baryCoord.x < 0.01 || gsOut.baryCoord.y < 0.01 ||
  //    gsOut.baryCoord.z < 0.01)
	////if (min(min(gsOut.baryCoord.x, gsOut.baryCoord.y), gsOut.baryCoord.z) < 0.01)
  //{
  //  fragColor = vec4(0.2, 0.2, 0.2, 1);
  //}
	//else
	//{
	//	//fragColor = vec4(0, 0, 0, 0);
	//	discard;
	//}
	//fragColor = vec4(0.0, 0.0, 0.0, (1.0-edgeFactor())*0.95);
	float d = edgeFactor();
	if (d < 0.3)
	{
    fragColor = vec4(0.2, 0.2, 0.2, 1);
	}
	else
	{
		discard;
	}
}

float edgeFactor()
{
	vec3 d = fwidth(gsOut.baryCoord);
	vec3 a3 = smoothstep(vec3(0.0), d*1.5, gsOut.baryCoord);
	return min(min(a3.x, a3.y), a3.z);
}
